/*
 * action.h -- Enfle action binding header
 * (C)Copyright 1999 by Hiroshi Takekawa
 * This file is part of Enfle.
 *
 * Last Modified: Wed Oct  6 04:04:23 1999.
 * $Id: action.h,v 1.2 1999/10/07 13:32:16 sian Exp $
 *
 * Enfle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Enfle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include "browse.h"
#include "hash.h"
#include <X11/X.h>
#include <X11/keysym.h>

typedef struct {
  KeySym keysym;
  int state;
  Event (*func)(Info *, Binfo *, Image *, Dlist_data *);
} Action_key;

Event action(Hash *, char *, Info *, Binfo *, Image *, Dlist_data *);
Event action_by_key(Hash *, KeySym, int, Info *, Binfo *, Image *, Dlist_data *);
int action_register(Hash *, char *, Event (*)(Info *, Binfo *, Image *, Dlist_data *));
int action_register_by_key(Hash *, KeySym, int, Event (*)(Info *, Binfo *, Image *, Dlist_data *));
int action_register_by_keys(Hash *, Action_key []);
