/*
 * browseaction.h -- Enfle main browsing actions header
 * (C)Copyright 1999, 2000 by Hiroshi Takekawa
 * This file is part of Enfle.
 *
 * Last Modified: Mon Jun 26 19:30:02 2000.
 * $Id: browseaction.h,v 1.9 2000/06/27 18:19:49 sian Exp $
 *
 * Enfle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Enfle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _BROWSEACTION_H
#define _BROWSEACTION_H

#include "image.h"
#include "dlist.h"

int browseaction_initialize(Hash *);

#define DECLARE_BROWSEACTION(name) Event browseaction_ ## name ## (Info *, Binfo *, Image *, Dlist_data *)
DECLARE_BROWSEACTION(delete);
DECLARE_BROWSEACTION(quit);
DECLARE_BROWSEACTION(flip_vertical);
DECLARE_BROWSEACTION(flip_horizontal);
DECLARE_BROWSEACTION(create_thumbnail);
DECLARE_BROWSEACTION(set_wallpaper);
DECLARE_BROWSEACTION(fullscreen);
DECLARE_BROWSEACTION(next);
DECLARE_BROWSEACTION(nextdir);
DECLARE_BROWSEACTION(prev);
DECLARE_BROWSEACTION(top);
DECLARE_BROWSEACTION(speed_slower);
DECLARE_BROWSEACTION(speed_faster);
DECLARE_BROWSEACTION(speed_normal);
DECLARE_BROWSEACTION(magnify);
DECLARE_BROWSEACTION(magnify_fit);
DECLARE_BROWSEACTION(magnify_fit_if_large);
DECLARE_BROWSEACTION(magnify_fit_short);
DECLARE_BROWSEACTION(restore);
DECLARE_BROWSEACTION(save_png);
DECLARE_BROWSEACTION(save_pms);
DECLARE_BROWSEACTION(save_jpeg);
DECLARE_BROWSEACTION(smooth);

#endif
