/*
 * bz2.h -- bz2 file handler header
 * (C)Copyright 1999 by Hiroshi Takekawa
 * This file is part of Enfle.
 *
 * Last Modified: Sun Apr 30 19:28:17 2000.
 * $Id: bz2.h,v 1.3 2000/05/08 09:53:39 sian Exp $
 *
 * Enfle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Enfle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _BZ2_H
#define _BZ2_h

#define FORMAT_NAME "BZ2"
#include "archive.h"
#include <bzlib.h>

/* API functions */
#ifdef BZAPI_NEEDS_PREFIX
# define BZOPEN  BZ2_bzopen
# define BZREAD  BZ2_bzread
# define BZERROR BZ2_bzerror
# define BZCLOSE BZ2_bzclose
#else
# define BZOPEN  bzopen
# define BZREAD  bzread
# define BZERROR bzerror
# define BZCLOSE bzclose
#endif

int bz2_archive_open(Archive *);
int bz2_archive_seek(Archive *, long, int);
int bz2_archive_tell(Archive *);
int bz2_archive_read(Archive *, unsigned char *, int);
int bz2_archive_close(Archive *);

typedef struct _bz2_info {
  int pos;
  BZFILE *bzfile;
} BZ2_info;

#endif
