/*
 * exe.h -- tar file handler header
 * (C)Copyright 2000 by TAJIRI Yasuhiro
 * This file is part of Enfle.
 *
 * Last Modified: Sat Jun 10 21:48:46 2000.
 * $Id: exe.h,v 1.1 2000/06/10 12:48:56 sian Exp $
 *
 * Enfle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Enfle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _EXE_H
#define _EXE_H

#define FORMAT_NAME	"EXE"
#define ENV_NAME	"ENFLE_SUSIE_PLUGIN_DIR"

typedef struct {
    unsigned long *positions;
    unsigned long *filesizes;
    unsigned char** names;
    
    unsigned char *data;
    unsigned long position;
} EXE_info;
typedef struct 
{
    int pos;
    int size;
    char* name;
}
EXE_RES_INFO;

int exe_archive_open(Archive *);
int exe_archive_select(Archive *, int);
int exe_archive_seek(Archive *, long, int);
int exe_archive_tell(Archive *);
int exe_archive_read(Archive *, unsigned char *, int);
int exe_archive_close(Archive *);
Dlist* getInfoList(FILE* fp);

#endif 
