/*
 * resinfo.c - resource handler code
 * (C)Copyright 2000 by TAJIRI Yasuhiro
 * This file is part of Enfle.
 *
 * Last Modified: Sat Jun 10 21:50:46 2000.
 * $Id: resinfo.c,v 1.1 2000/06/10 12:50:50 sian Exp $
 *
 * Enfle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Enfle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "dlist.h"
#include "utils.h"
#include "enfle.h"
#include "exe.h"
/*
 * Predefined Resource Types
 */
#define RT_CURSOR       1
#define RT_BITMAP       2
#define RT_ICON         3
#define RT_MENU         4
#define RT_DIALOG       5
#define RT_STRING       6
#define RT_FONTDIR      7
#define RT_FONT         8
#define RT_ACCELERATOR  9
#define RT_RCDATA       10
#define RT_MESSAGETABLE 11
#define RT_GROUP_CURSOR 12
#define RT_GROUP_ICON   14
#define RT_VERSION      16
#define RT_DLGINCLUDE   17
#define RT_PLUGPLAY     19
#define RT_VXD          20

Dlist* list;


//FILE *fp;

static void u2aprint(unsigned char *str, unsigned short strnum);
static char* u2a(unsigned char *str, unsigned short strnum);
static void putsID(int IntID)
{
    switch (IntID) {
        case RT_CURSOR:
        	puts("CURSOR"); break;
		case RT_BITMAP:
            puts("BITMAP"); break;
		case RT_ICON:
        	puts("ICON"); break;
        case RT_MENU:
        	puts("MENU"); break;
        case RT_DIALOG:
        	puts("DIALOG"); break;
		case RT_STRING:
        	puts("STRING"); break;
		case RT_FONTDIR:
        	puts("FONTDIR"); break;
		case RT_FONT:
        	puts("FONT"); break;
		case RT_ACCELERATOR:
        	puts("ACCELERATOR"); break;
		case RT_RCDATA:
        	puts("RCDATA"); break;
		case RT_MESSAGETABLE:
        	puts("MESSAGETABLE"); break;
		case RT_GROUP_CURSOR:
        	puts("GROUP_CURSOR"); break;
		case RT_GROUP_ICON:
        	puts("GROUP_ICON"); break;
        case RT_VERSION:
        	puts("VERSION"); break;
        case RT_DLGINCLUDE:
        	puts("DLGINCLUDE"); break;
		case RT_PLUGPLAY:
        	puts("PLUGPLAY"); break;
		case RT_VXD:
        	puts("VXD"); break;
        default:
        	printf("0x%x", IntID);
    }//if(IntID!=RT_RCDATA)continue;
}

static void 
getLangNumS(int LangEntPos,int LangNumS,int PRawData,int VAddr,FILE* fp)
{
    int l;
    int StrPos;
    int DataEntPos;
    int StrNum;
    int DataPos;
    int DataSize=0;    
    unsigned char Str[512];   /* Ƥȡʥ */
    EXE_RES_INFO *info;
    unsigned char buf[4];
    
    for (l = 0; l < LangNumS; l++) {
        fseek(fp, LangEntPos + l * 8, SEEK_SET);
        
        fread(buf, 4, 1, fp);
        //printf("StrPos:0x%x\n", StrPos);
        StrPos = 0x7fffffff & get_little_dword(buf);
        //printf("StrPos:0x%x\n", StrPos);
        fread(buf, 4, 1, fp);
        DataEntPos = get_little_dword(buf);
        
        //printf("PRawData + StrPos:0x%x\n", PRawData + StrPos);
        fseek(fp, PRawData + StrPos, SEEK_SET);
        fread(buf, 2, 1, fp);
        StrNum=get_little_word(buf);
        
        //printf("StrNum:0x%x\n", StrNum);
        fread(Str, StrNum * 2, 1, fp);
        puts("\t\t");
        u2aprint(Str, StrNum);
        //putchar('\n');
        fseek(fp, PRawData + DataEntPos, SEEK_SET);
        fread(buf, 4, 1, fp);
        DataPos=get_little_dword(buf);
        
        DataPos = DataPos + PRawData - VAddr;
        fread(buf, 4, 1, fp);
        DataSize=get_little_dword(buf);
//        printf("\t0x%x\t0x%x\n", DataPos,DataSize);
        info = malloc(sizeof(EXE_RES_INFO));
        info->pos=DataPos;
        info->size=DataSize;
        info->name=u2a(Str,StrNum);
        dlist_add(list ,info);
        
    }
}

static void  getLangNumI(int LangEntPos, int LangNumS,int LangNumI,int PRawData, int VAddr,FILE *fp,char *name)
{
    int IntID,SubDirPos,DataPos;
    int l;
    EXE_RES_INFO *info;
    char buf[4];
            
    for (l = 0; l < LangNumI; l++) {
        int DataSize=0;
        fseek(fp, LangEntPos + LangNumS * 8 + l * 8, SEEK_SET);
        
        fread(buf, 4, 1, fp);
        IntID = get_little_dword(buf);
        
//        printf("\t\t0x%x", IntID);
        fread(buf, 4, 1, fp);
        SubDirPos=get_little_dword(buf);
        SubDirPos &= 0x7fffffff;
        
        fseek(fp, PRawData + SubDirPos, SEEK_SET);
        fread(buf, 4, 1, fp);
        DataPos=get_little_dword(buf);
        DataPos = DataPos + PRawData - VAddr;
        fread(buf, 4, 1, fp);
        DataSize = get_little_dword(buf);
//        printf("\t0x%x\t0x%x\n", DataPos,DataSize);
        info = malloc(sizeof(EXE_RES_INFO));
        info->pos=DataPos;
        info->size=DataSize;
        info->name=name;
        

        dlist_add(list ,info);
        

    }
}

static void getNameNumS(int NameEntPos,int NameNumS,int PRawData,int VAddr,FILE* fp)
{
    int k;
    unsigned int StrPos,SubDirPos, LangEntPos;
    unsigned short StrNum,LangNumS,LangNumI;
    unsigned char Str[512];   /* Ƥȡʥ */    
    char buf[4];
    for (k = 0; k < NameNumS; k++) {
        fseek(fp, NameEntPos + k * 8, SEEK_SET);

        fread(buf, 4, 1, fp);
        StrPos=get_little_dword(buf);
        //printf("StrPos:0x%x\n", StrPos);
        StrPos &= 0x7fffffff;
        //printf("StrPos:0x%x\n", StrPos);
        fread(buf, 4, 1, fp);
        SubDirPos = get_little_dword(buf);
        SubDirPos &= 0x7fffffff;
        //printf("PRawData + StrPos:0x%x\n", PRawData + StrPos);
        fseek(fp, PRawData + StrPos, SEEK_SET);
        fread(buf, 2, 1, fp);
        StrNum = get_little_word(buf);
        //printf("StrNum:0x%x\n", StrNum);
        fread(Str, StrNum * 2, 1, fp);
        putchar('\t');
//        u2aprint(Str, StrNum);
        putchar('\n');
        
        fseek(fp, PRawData + SubDirPos, SEEK_SET);
        fseek(fp, 12, SEEK_CUR);
        
        fread(buf, 2, 1, fp);
        LangNumS=get_little_word(buf);
        fread(buf, 2, 1, fp);
        LangNumI=get_little_word(buf);

        LangEntPos = PRawData + SubDirPos + 16;
        getLangNumS(LangEntPos,LangNumS,PRawData, VAddr,fp);
        getLangNumI(LangEntPos, LangNumS,LangNumI,PRawData, VAddr,fp,u2a(Str,StrNum));
    }
}
static void getNameNumI(int NameEntPos,int NameNumS,int NameNumI,int PRawData,int VAddr,FILE* fp)
{
    int k;
    unsigned int SubDirPos, LangEntPos;
    unsigned short LangNumS,LangNumI;
    unsigned char Str[512];   /* Ƥȡʥ */    
    char buf[4];
    for (k = 0; k < NameNumI; k++) {
        int IntID;
        
        fseek(fp, NameEntPos + NameNumS * 8 + k * 8, SEEK_SET);
        
        fread(buf, 4, 1, fp);
        IntID = get_little_dword(buf);
        
        sprintf(Str,"IDx%x\n", IntID);
//        printf("##\t0x%s\n", Str);
        fread(buf, 4, 1, fp);
        SubDirPos = get_little_dword(buf);
        
        SubDirPos &= 0x7fffffff;
        
        fseek(fp, PRawData + SubDirPos, SEEK_SET);
        fseek(fp, 12, SEEK_CUR);
        
        fread(buf, 2, 1, fp);
        LangNumS=get_little_word(buf);
        fread(buf, 2, 1, fp);
        LangNumI=get_little_word(buf);
        LangEntPos = PRawData + SubDirPos + 16;
        getLangNumS(LangEntPos,LangNumS,PRawData, VAddr,fp);
        getLangNumI(LangEntPos,LangNumS,LangNumI,PRawData, VAddr,fp,strdup(Str));

    }
}
static void getNameNum(int SubDirPos,int PRawData,int VAddr,FILE* fp)
{
    unsigned short NameNumS, NameNumI;
    unsigned int NameEntPos;
    char buf[2];

    fseek(fp, PRawData + SubDirPos, SEEK_SET);
    fseek(fp, 12, SEEK_CUR);
    fread(buf, 2, 1, fp);
    NameNumS= get_little_word(buf);
    fread(buf, 2, 1, fp);
    NameNumI= get_little_word(buf);
    NameEntPos = PRawData+ SubDirPos + 16;
    getNameNumS(NameEntPos,NameNumS,PRawData, VAddr,fp);
    getNameNumI(NameEntPos,NameNumS,NameNumI,PRawData, VAddr,fp);
}

Dlist* getInfoList(FILE* fp)
{
    unsigned long i;
    int j;
    char signature[4];
    unsigned short SecNum;
    unsigned short OptHdSize;
    char SecName[8];
    unsigned long VAddr = 0, PRawData = 0;
    unsigned short TypeNumS, TypeNumI;
    unsigned long TypeEntPos;
    
    unsigned long SubDirPos;
    unsigned char Str[512];   /* Ƥȡʥ */
    unsigned long StrPos;
    unsigned short StrNum;
    int IntID;
    char buf[4];
    
    fseek(fp, 0x3c, SEEK_SET);
	fread(buf, 4, 1, fp);
    i = get_little_dword(buf);
    fseek(fp, i, SEEK_SET);
    fread(signature, 1, 4, fp);
    if (strncmp("PE\0\0", signature, 4) != 0) {
//    	printf("PEʤǤ\n");
        goto error;
    }
    fseek(fp, 2, SEEK_CUR);
    fread(buf, 2, 1, fp);
    SecNum = get_little_word(buf);
    
    //printf("ο:%d\n", SecNum);
    fseek(fp, 12, SEEK_CUR);
    fread(buf, 2, 1, fp);
    OptHdSize=get_little_word(buf);
    //printf("ץإåΥ:0x%x\n", OptHdSize);
    fseek(fp, i + 4 + 20 + OptHdSize, SEEK_SET);

    for (j = 0; j < SecNum; j++) {
    	fread(SecName, 1, 8, fp);
        if (strncmp(".rsrc\0\0\0", SecName, 8) == 0) {
            fseek(fp, 4, SEEK_CUR);
            fread(buf, 4, 1, fp);
            VAddr = get_little_dword(buf);
            fseek(fp, 4, SEEK_CUR);
            fread(buf, 4, 1, fp);
            PRawData = get_little_dword(buf);
//          printf("ۥɥ쥹:0x%x\n", VAddr);
//          printf("RawDataؤΥݥ󥿡:0x%x\n", PRawData);

            break;
        }
        fseek(fp, 32, SEEK_CUR);
    }
    if (j == SecNum) {
//    	printf(".rsrc󤬤ʤǤ\n");
        goto error;
    }
    /* ˤĤƤwinnt.h򸫤٤ */
    puts("\t̾\t\tǡ\n");

    fseek(fp, PRawData, SEEK_SET);
    fseek(fp, 12, SEEK_CUR);
    fread(buf, 2, 1, fp);
    TypeNumS = get_little_word(buf);
    fread(buf, 2, 1, fp);
    TypeNumI = get_little_word(buf);
//    printf("TypeNumS:%d\n", TypeNumS);
//    printf("TypeNumI:%d\n", TypeNumI);
    TypeEntPos = PRawData + 16;
    list = dlist_create();
    
    for (j = 0; j < TypeNumS; j++) {
    	fseek(fp, TypeEntPos + j * 8, SEEK_SET);
        fread(buf, 4, 1, fp);
        StrPos = get_little_dword(buf);
        
        //printf("StrPos:0x%x\n", StrPos);
        StrPos &= 0x7fffffff;
        //printf("StrPos:0x%x\n", StrPos);
        fread(buf, 4, 1, fp);
        SubDirPos = get_little_dword(buf);
        SubDirPos &= 0x7fffffff;
        //printf("PRawData + StrPos:0x%x\n", PRawData + StrPos);
        fseek(fp, PRawData + StrPos, SEEK_SET);
        
        fread(buf, 2, 1, fp);
        StrNum = get_little_word(buf);
        
        //printf("StrNum:0x%x\n", StrNum);
        fread(Str, StrNum * 2, 1, fp);
        u2aprint(Str, StrNum);
        putchar('\n');
        getNameNum(SubDirPos,PRawData, VAddr,fp);
    }
    for (j = 0; j < TypeNumI; j++) {
    	fseek(fp, TypeEntPos + TypeNumS * 8 + j * 8, SEEK_SET);
        fread(&IntID, 4, 1, fp);
        //printf("IntID:0x%x\n", IntID);
        putsID(IntID);
        //putchar('\n');
        fread(buf, 4, 1, fp);
        SubDirPos = get_little_dword(buf);
        SubDirPos &= 0x7fffffff;
        getNameNum(SubDirPos,PRawData, VAddr,fp);
    }
    return list;
  error:
//    if(list)
//        free(list);
    return NULL;
    
}
#if 0
int main(int argc, char *argv[])
{
    FILE* fp;
    int i;
    
    Dlist* list;
    
	if (argc != 2) {
    	exit(1);
    }
    if ((fp = fopen(argv[1], "rb")) == NULL) {
    	exit(1);
    }
    list = getInfoList(fp);
    {
        Dlist_data * data = dlist_gettop(list);
        int num = dlist_getndata(list);
        for(i=0;i<num;i++){
            EXE_RES_INFO* info = (EXE_RES_INFO*)data->data;
            int i;
            printf("%s\t0x%x\t0x%x\n", info->name,info->pos,info->size);
            data=data->next;
            
        }
    }
    


	return 0;
}
#endif
static void u2aprint(unsigned char *str, unsigned short strnum)
{
	int i;

    for (i = 0; i < strnum; i++) {
    	putchar((int)str[i * 2]);
    }
}
static char* u2a(unsigned char* str,unsigned short strnum)
{
    char* s = malloc(strnum+1);
    int i;
    
    for (i = 0; i < strnum; i++) {
    	s[i]= str[i * 2];
    }
    str[strnum]=0;
    return s;
}
