/*
 * one.h -- ONE archive handler header
 * (C)Copyright 2000 by TAJIRI Yasuhiro
 * This file is part of Enfle.
 *
 * Last Modified: Thu Aug 10 07:22:42 2000.
 * $Id: one.h,v 1.1 2000/08/09 22:24:40 sian Exp $
 *
 * Enfle is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Enfle is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#define FORMAT_NAME "ONE"

#define PAK_KEY_LEN 11
typedef enum {
  BMP,
  JPEG
} ONE_type;

typedef struct
{
    unsigned char byte;
    int len;
} ONE_info_bmp;

typedef struct {
  int offsets;
  int sizes;
} ONE_info_table;

typedef struct {
    ONE_info_table* table;
    ONE_type type;
    MFILE* bmp_file;
} ONE_info;

int one_archive_open(Archive *);
int one_archive_close(Archive *);
int init_one_info(ONE_info *, int);

int one_archive_select(Archive *, int);
int one_archive_read(Archive *, unsigned char *, int);
