/*
 * pak.h -- pak file handler header
 * (C)Copyright 1998, 99 by Hiroshi Takekawa
 * Last Modified: Fri Jul  9 04:13:25 1999.
 * $Id: pak.h,v 1.3 1999/07/09 07:44:52 sian Exp $
 */

#define FORMAT_NAME "PAK"

#define PAK_KEY_LEN 11

typedef enum {
  _LVN,
  _FANDISK
} PAK_type;

typedef struct {
  PAK_type type;
  char **filenames;
  int *offsets;
  int *sizes;
  int *flags; /* for FANDISK */
  int nfiles; /* for FANDISK */
  int position; /* for FANDISK */
  unsigned char *data; /* for FANDISK */
  int key[PAK_KEY_LEN]; /* for LVN */
} PAK_info;

int pak_archive_open(Archive *);
int pak_lvn_archive_open(Archive *);
int pak_fan_archive_open(Archive *);
int pak_archive_close(Archive *);
int init_pak_info(PAK_info *, int);
