/*
 * pms.h -- pms file expander header
 * (C)Copyright 1998 by Hiroshi Takekawa
 *
 * Last Modified: Mon Sep 13 06:25:52 1999.
 */

#define PIX16R(p) (((p) & 0xf800) >> 8)
#define PIX16G(p) (((p) & 0x07e0) >> 3)
#define PIX16B(p) (((p) & 0x001f) << 3)
#define PIX16(r,g,b) ((((r) & 0xf8) << 8) | (((g) & 0xfc) << 3) | ((b) >> 3))

typedef struct _pms_info {
  int version;
  int headersize;
  int depth, depths;
  int sf, bf;
  int x, y;
  int width, height;
  int d_offset;
  int p_offset;
  int c_offset;
  unsigned char palette[256][3];
  unsigned char *image;
  unsigned char *comment;
} PMS_info;

PMS_info *PMS_load(unsigned char *);
